﻿using System;
using System.Reflection;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.GridView;
using Expression = System.Linq.Expressions.Expression;

namespace TelerikRadGridViewProblems
{
	public class MyGridViewCheckBoxColumn : GridViewCheckBoxColumn
	{
		[RoutedEvent]
		public event RoutedEventHandler Click;

		static readonly Lazy<Func<GridViewCheckBoxColumn, bool>> GVCBCbeginEditWithKeyboard = new Lazy<Func<GridViewCheckBoxColumn, bool>>(() =>
		{
			var gvcbcExp = Expression.Parameter(typeof(GridViewCheckBoxColumn), "gvcbc");
			return Expression.Lambda<Func<GridViewCheckBoxColumn, bool>>(
				Expression.Field(
					gvcbcExp,
					typeof(GridViewCheckBoxColumn).GetField("beginEditWithKeyboard", BindingFlags.Instance | BindingFlags.NonPublic)
				),
				gvcbcExp
			).Compile();
		});

		static readonly Lazy<Func<GridViewCheckBoxColumn, bool>> GVCBCbeginEditWithTouch = new Lazy<Func<GridViewCheckBoxColumn, bool>>(() =>
		{
			var gvcbcExp = Expression.Parameter(typeof(GridViewCheckBoxColumn), "gvcbc");
			return Expression.Lambda<Func<GridViewCheckBoxColumn, bool>>(
				Expression.Field(
					gvcbcExp,
					typeof(GridViewCheckBoxColumn).GetField("beginEditWithTouch", BindingFlags.Instance | BindingFlags.NonPublic)
				),
				gvcbcExp
			).Compile();
		});

		public override FrameworkElement CreateCellEditElement(GridViewCell cell, object dataItem)
		{
			var checkBox = base.CreateCellEditElement(cell, dataItem) as CheckBox;
			checkBox.Click += this.CheckBoxClick;
			return checkBox;
		}

		void CheckBoxClick(object sender, RoutedEventArgs e) => this.Click?.Invoke(sender, e);

		protected override object PrepareCellForEdit(FrameworkElement editingElement, RoutedEventArgs editingEventArgs)
		{
			object obj = base.PrepareCellForEdit(editingElement, editingEventArgs);
			if (editingElement is CheckBox && (MyGridViewCheckBoxColumn.GVCBCbeginEditWithKeyboard.Value(this) || MyGridViewCheckBoxColumn.GVCBCbeginEditWithTouch.Value(this) ||
				editingEventArgs is MouseButtonEventArgs) && this.AutoSelectOnEdit)
				this.CheckBoxClick(editingElement, editingEventArgs);
			return obj;
		}
	}
}
