﻿using System.Collections.Generic;
using System.Linq;
using System.Windows.Input;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.GridView;

namespace TelerikRadGridViewProblems
{
	public class MyKeyboardCommandProvider : DefaultKeyboardCommandProvider
	{
		readonly GridViewDataControl parentGrid;

		public MyKeyboardCommandProvider(GridViewDataControl dataControl) : base(dataControl) => this.parentGrid = dataControl;

		public override IEnumerable<ICommand> ProvideCommandsForKey(Key key)
		{
			var commands = base.ProvideCommandsForKey(key == Key.Enter ? Key.Tab : key).ToList();
			bool shift = (Keyboard.Modifiers & ModifierKeys.Shift) != 0;
			if ((key == Key.Enter || key == Key.Tab) && !shift)
			{
				var dataContext = this.parentGrid.DataContext as MainWindowViewModel;
				if (this.parentGrid.CurrentColumn.DisplayIndex == 2 && dataContext.CurrentItem == null)
				{
					commands.Clear();
					commands.Add(RadGridViewCommands.MoveNext);
				}
			}
			return commands;
		}
	}
}
